import { createRuntime } from 'babel-plugin-jsx-dom-expressions';
import { Sync, onClean, unwrap } from 'solid-js';

var index = createRuntime({
  wrapExpr: function(accessor, fn) {
    return new Sync(() => {
      var dispose, value;
      value = accessor();
      if ((value != null) && typeof value === 'object') {
        if ('sid' in value) {
          new Sync(() => {
            return fn(value.value);
          });
          return;
        }
        if ('subscribe' in value) {
          dispose = value.subscribe(fn);
          onClean('unsubscribe' in dispose ? dispose.unsubscribe.bind(dispose) : dispose);
          return;
        }
        if ('then' in value) {
          value.then(fn);
          return;
        }
      }
      return fn(value);
    });
  },
  sanitize: unwrap
});

export default index;
