'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var babelPluginJsxDomExpressions = require('babel-plugin-jsx-dom-expressions');
var solidJs = require('solid-js');

var index = babelPluginJsxDomExpressions.createRuntime({
  wrapExpr: function(accessor, fn) {
    return new solidJs.Sync(() => {
      var dispose, value;
      value = accessor();
      if ((value != null) && typeof value === 'object') {
        if ('sid' in value) {
          new solidJs.Sync(() => {
            return fn(value.value);
          });
          return;
        }
        if ('subscribe' in value) {
          dispose = value.subscribe(fn);
          solidJs.onClean('unsubscribe' in dispose ? dispose.unsubscribe.bind(dispose) : dispose);
          return;
        }
        if ('then' in value) {
          value.then(fn);
          return;
        }
      }
      return fn(value);
    });
  },
  sanitize: solidJs.unwrap
});

exports.default = index;
